black = Color.new(0, 0, 0)
white = Color.new(255, 255, 255)
yellow = Color.new(255,255,0)
red = Color.new(255, 0, 0)
green = Color.new(0, 255, 0)
darkgreen =Color.new(0,150,0)
blue = Color.new(85, 26, 139)
gray = Color.new(128, 128, 128)
cyan = Color.new(100, 255, 255)
orange = Color.new(255,165,0)
pink = Color.new(255,20,147)
screen:clear(black)
proportional2 = Font.createProportional()
proportional2:setPixelSizes(0, 64)
background1 =Image.load("solitareimages/background1.png")
background2 =Image.load("solitareimages/background2.png")
background3 =Image.load("solitareimages/background3.png")
optionsfile = "OPTIONS.LUA"
errormessage =""
options = 1222
colourarray={{green,gray},{gray,white,gray},{gray,white,gray},{gray,white,gray,gray},{gray,gray},{gray,gray}}
row = 1
column = 2
gameoptions ={{"","Start"},{"Game Mode","Draw Three","Draw One"},{"Game Type","Standard","Vegas"},{"Deck",background1,background2,background3},{"","Controls"},{"","Quit"}}
gameoptionsselected ={"","Draw Three","Standard",background1}

function drawsquarebydimension(x1,y1,x2,y2,linecolour)

    screen:drawLine(x1,y1,x1+x2,y1,linecolour)
    screen:drawLine(x1+x2,y1,x1+x2,y1+y2,linecolour)
    screen:drawLine(x1,y1+y2,x1+x2,y1+y2,linecolour)
    screen:drawLine(x1,y1,x1,y1+y2,linecolour)
end


function changeoptions(direction,gameoptions) -- 1 left,2 right,3 up, 4 down
    colourarray={{gray,gray},{gray,gray,gray},{gray,gray,gray},{gray,gray,gray,gray},{gray,gray},{gray,gray}}
    local tempoptions = 1
   
    if direction == 1 then
        if column == 2 then
            column = table.getn(gameoptions[row])
        else
            column = column -1
        end
        gameoptionsselected[row] = gameoptions[row][column]
        --colourarray[row][column] = white
    elseif direction == 2 then
        if column == table.getn(gameoptions[row]) then
            column = 2
        else
            column = column +1
        end
        gameoptionsselected[row] = gameoptions[row][column]
        --colourarray[row][column] = white
    elseif direction == 3 then
        if row == 1 then
            row = 6
        else
            row = row -1
        end
        column = 2
        
    else
        if row == 6 then
            row = 1
        else
            row = row +1
        end
        column = 2
    end
    
    for i = 2 ,4 do
        tempoptions = tempoptions * 10
        for j = 2,table.getn(gameoptions[i]) do
            if gameoptionsselected[i] == gameoptions[i][j] then
                colourarray[i][j]= white
                tempoptions = tempoptions + j
            end
        end
    end
    colourarray[row][1] = green
    options = tempoptions
end

function saveoptions()
	file = io.open(optionsfile, "w")
	if file then
		file:write(options)
		file:close()
	end
end
 
function loadoptions()
	file = io.open(optionsfile, "r")
	if file then
		options = file:read("*n")
		file:close()
	end
end
function drawall()
    screen:clear(black)
    screen:fontPrint(proportional2, 120, 60, "Solitare", yellow)
    screen:print(370,50,"V2.0",yellow)
    screen:print(140,70,"Developed by Pradeep M Kumar",yellow)
    
    xoffset = 0
    yoffset = 20
   
    screen:print (xoffset+ 25,yoffset+ 70,gameoptions[1][2],colourarray[1][1])
    screen:print (xoffset+ 25,yoffset+ 90,gameoptions[2][1],colourarray[2][1])
    screen:print (xoffset+ 125,yoffset+ 90,gameoptions[2][2],colourarray[2][2])
    screen:print (xoffset+ 225,yoffset+ 90,gameoptions[2][3],colourarray[2][3])
    screen:print (xoffset+ 25,yoffset+ 110,gameoptions[3][1],colourarray[3][1])
    screen:print (xoffset+ 125,yoffset+ 110,gameoptions[3][2],colourarray[3][2])
    screen:print (xoffset+ 225,yoffset+ 110,gameoptions[3][3],colourarray[3][3])
    screen:print (xoffset+ 25,yoffset+ 130,gameoptions[4][1],colourarray[4][1])
    screen:blit (xoffset + 108,yoffset+ 135,gameoptions[4][2])
    screen:blit (xoffset + 168,yoffset+ 135,gameoptions[4][3])
    screen:blit (xoffset + 228,yoffset+ 135,gameoptions[4][4])
    drawsquarebydimension(xoffset + 108 -2,yoffset+ 135 -2,background1:width()+4,background1:height()+4,colourarray[4][2])
    drawsquarebydimension(xoffset + 168 -2,yoffset+ 135 -2,background1:width()+4,background1:height()+4,colourarray[4][3])
    drawsquarebydimension(xoffset + 228 -2,yoffset+ 135 -2,background1:width()+4,background1:height()+4,colourarray[4][4])
    screen:print (xoffset+ 25,yoffset+ 210,gameoptions[5][2],colourarray[5][1])
    screen:print (xoffset+ 25,yoffset+ 230,gameoptions[6][2],colourarray[6][1])

    errormessage = "P "..options.." "..row
--    screen:print(20,200,errormessage,white)
   
    screen.waitVblankStart()
    screen.flip()
end

while true do
    pad = Controls.read()
    
    if pad:start() then
    	file = io.open(optionsfile, "w")
	    if file then
		file:write(options)
		file:close()
		System.sleep(400)
        dofile("game.lua")
	    end
    end
    
    if pad:triangle() then
        System.sleep(200)
        loadoptions()
        errormessage = errormessage.." "..options
        gametype = math.mod(options,10)
        scoretype = math.mod(options-gametype,100)/10
        decktype = math.mod(options-gametype-scoretype*10,1000)/100
    end
    
    if pad:square() then
        System.sleep(200)
        saveoptions(options)
        errormessage = errormessage.." "..options
    end
    if pad:left() then
        System.sleep(200)
        changeoptions(1,gameoptions)
    end
    if pad:right() then
        System.sleep(200)
        changeoptions(2,gameoptions)
    end
        if pad:up() then
        System.sleep(200)
        changeoptions(3,gameoptions)
    end
        if pad:down() then
        System.sleep(200)
        changeoptions(4,gameoptions)
    end
    if pad:cross() then
        System.sleep(200)
        if row == 6 then
            break
        elseif row == 1 then
            file = io.open(optionsfile, "w")
    	    if file then
        		file:write(options)
        		file:close()
        		System.sleep(400)
                dofile("game.lua")
    	    end
    	elseif row == 5 then
    	   dofile("controls.lua")
        end
    end
    if pad:l() then
        System.sleep(200)
        screen:save("screenshot.png")
        break
    end
    drawall()
end
